jQuery.noConflict();
jQuery(document).ready(function () {//alert('a');
	var up1 = new Uploader();
	up1.inicia();
});

var Uploader = function () {
	this.datos = {
		capa: '#zona_upload',
		capaMensajeResultado: '#mensaje_resultado',
		capaPrincipal: '#contenedor',
		capaContenido: '#contenido',
		contenedorUpload: '#zona_upload p',
		elementoContenedorUpload: 'p',
		htmlEnlaceUpload: '<p><a href="#" id="anadir_archivo">Añadir archivo</a></p>',
		enlaceUpload: '#anadir_archivo',
		htmlUpload: '<p class="clear varios_archivos"><label><span>Seleccionar archivo:</span><input type="file" name="archivos[]" /></label><a href="#">Eliminar</a></p>',
		elementoHtmlUpload: '#formulario_archivos p.varios_archivos',
		elementoHtmlUploadPrimero: '#arch_inicial',
		prefijoUpload: 'arch_',
		formulario: '#formulario_archivos',
		capaListadoArchivos: '#lista_archivos',
		urlListadoArchivos: 'uploader.php?listar=si&js=si',
		urlMensajeConfirmacion: 'mensaje.php?js=si',
		urlMensajeResultado: 'mensaje_resultado.php?js=si',
		urlEliminarConfirmado: 'uploader.php?eliminar=si&js=si',
		idIframe: 'iframe_archivos',
		idMensajeIframe: '#iframe_mensaje',
		despuesMensaje: '#fin_cabecera',
		srcIframe: 'vacio.html',
		enlaceEliminar: '#lista_archivos a.eliminar',
		enlaceEliminarAceptar: '#enlace_aceptar',
		enlaceEliminarCancelar: '#enlace_cancelar'
	}
	
	this.inicia = function () {
		var that = this;
		that.enlaceAnadirUpload();
		that.iframeUpload();
		that.envioFormulario();
		that.eliminarArchivo();
	}
	
	this.iframeUpload = function () {
		var that = this;
		jQuery('body').eq(0).append('<iframe src="'+that.datos.srcIframe+'" id="'+that.datos.idIframe+'" name="'+that.datos.idIframe+'"></iframe');
		jQuery(that.datos.formulario).attr('target',that.datos.idIframe);
		jQuery(that.datos.formulario).append('<input type="hidden" name="js" value="si" />');
	}
	
	this.enlaceAnadirUpload = function () {
		var that = this;
		jQuery(that.datos.capa).parent().append(that.datos.htmlEnlaceUpload);
		jQuery(that.datos.enlaceUpload).click(function () {that.anadirUpload();});
	}
	
	this.anadirUpload = function () {
		var that = this;
		var numero = Math.floor(Math.random()*1001);
		jQuery(that.datos.capa).append(that.datos.htmlUpload);
		jQuery(that.datos.contenedorUpload+':last label').eq(0).attr('for',that.datos.prefijoUpload+numero);
		jQuery(that.datos.contenedorUpload+':last input').eq(0).attr('id',that.datos.prefijoUpload+numero);
		
		jQuery(that.datos.contenedorUpload+':last a').eq(0).click(function () {
			jQuery(this).closest(that.datos.elementoContenedorUpload).remove();
		})
	}
	
	this.envioFormulario = function () {
		var that = this;
		jQuery(that.datos.formulario).one('submit',function () {
			jQuery('#'+that.datos.idIframe).one('load',function () {
				jQuery(that.datos.elementoHtmlUploadPrimero).attr('value','');
				jQuery(that.datos.elementoHtmlUpload).remove();
				that.mensajeResultado();
				that.envioFormulario();
				that.cargaListadoArchivos();
			});
		});
	}
	
	this.mensajeResultado = function () {
		var that = this;
		jQuery(that.datos.capaMensajeResultado).remove();
		var valorMensaje = jQuery('#'+that.datos.idIframe).contents().find(that.datos.idMensajeIframe).html();
		
		jQuery.get(that.datos.urlMensajeResultado+'&mensaje='+valorMensaje, function(html) {
			jQuery(that.datos.despuesMensaje).before(html);
		});
	}
	
	this.eliminarArchivo = function () {
		var that = this;
		jQuery(that.datos.enlaceEliminar).live('click',function () {
			var archivo = jQuery(this).attr('rel');
			var url = that.datos.urlMensajeConfirmacion+'&archivo='+archivo;
			jQuery(that.datos.capaMensajeResultado).remove();
			jQuery(that.datos.capaListadoArchivos).empty().hide();
			jQuery(that.datos.capaContenido).hide().before('<div id="mensaje_eliminar"></div>');
			jQuery('#mensaje_eliminar').load(url,function () {
				
				jQuery(that.datos.enlaceEliminarCancelar).one('click',function () {
					that.restaurar();
					return false;
				});
				
				jQuery(that.datos.enlaceEliminarAceptar).attr('target',that.datos.idIframe).attr('href',that.datos.urlEliminarConfirmado+'&archivo='+archivo);
				jQuery(that.datos.enlaceEliminarAceptar).one('click',function () {
					jQuery('#'+that.datos.idIframe).one('load',function () {
						that.mensajeResultado();
						that.restaurar();
					});
				});
			});
			return false;
		});
	}
	
	this.cargaListadoArchivos = function () {
		var that = this;
		var aleatorio = Math.floor(Math.random()*10001);
		jQuery(that.datos.capaListadoArchivos).empty().load(that.datos.urlListadoArchivos+'&random='+aleatorio).show();
	}
	
	this.restaurar = function () {
		var that = this;
		jQuery(that.datos.capaContenido).show();
		jQuery('#mensaje_eliminar').remove();
		that.cargaListadoArchivos();
	}
}